import { ref as v, inject as O, provide as h, onMounted as L, markRaw as A, nextTick as I, onBeforeUnmount as k } from "vue";
import { Functions as p, Utilities as l, InjectionKeys as g } from "@vue-leaflet/vue-leaflet";
const f = {
  ...p.Layer.layerProps,
  draggable: {
    type: Boolean,
    custom: !0,
    default: !1
  },
  icon: {
    type: [Object],
    default: () => {
    },
    custom: !1
  },
  zIndexOffset: {
    type: Number,
    custom: !1,
    default: null
  },
  latLng: {
    type: [Object, Array],
    custom: !0,
    required: !0
  },
  pane: {
    type: String,
    default: "markerPane"
  },
  opacity: {
    type: Number,
    default: () => 1,
    custom: !1
  },
  rotationAngle: {
    type: Number,
    custom: !0
  },
  rotationOrigin: {
    type: String,
    custom: !1,
    default: "center"
  }
}, _ = (e, n, t) => {
  const { options: a, methods: i } = p.Layer.setupLayer(
    e,
    n,
    t
  ), y = l.propsToLeafletOptions(e, f, a), u = {
    ...i,
    setDraggable(o) {
      n.value.dragging && (o ? n.value.dragging.enable() : n.value.dragging.disable());
    },
    latLngSync(o) {
      t.emit("update:latLng", o.latlng), t.emit("update:lat-lng", o.latlng);
    },
    setOpacity(o) {
      n.value && n.value.setOpacity(o);
    },
    setLatLng(o) {
      if (o != null && n.value) {
        const c = n.value.getLatLng();
        (!c || !c.equals(o)) && n.value.setLatLng(o);
      }
    },
    setRotationAngle(o) {
      n.value && n.value.setRotationAngle(o);
    }
  };
  return { options: y, methods: u };
};
function b(e) {
  const n = e.Marker.prototype._initIcon, t = e.Marker.prototype._setPos, a = e.DomUtil.TRANSFORM === "msTransform";
  e.Marker.addInitHook(function() {
    this.options.rotationOrigin = this.options.rotationOrigin, this.options.rotationAngle = this.options.rotationAngle, this.on("drag", function(i) {
      i.target._applyRotation();
    });
  }), e.Marker.include({
    _initIcon: function() {
      n.call(this);
    },
    _setPos: function(i) {
      t.call(this, i), this._applyRotation();
    },
    _applyRotation: function() {
      this.options.rotationAngle && (this._icon.style[e.DomUtil.TRANSFORM + "Origin"] = this.options.rotationOrigin, a ? this._icon.style[e.DomUtil.TRANSFORM] = "rotate(" + this.options.rotationAngle + "deg)" : this._icon.style[e.DomUtil.TRANSFORM] += " rotateZ(" + this.options.rotationAngle + "deg)");
    },
    setRotationAngle: function(i) {
      return this.options.rotationAngle = i, this.update(), this;
    },
    setRotationOrigin: function(i) {
      return this.options.rotationOrigin = i, this.update(), this;
    }
  });
}
const M = (e, n) => {
  let t;
  return function(...a) {
    t && clearTimeout(t), t = setTimeout(() => {
      e.apply(this, a), t = null;
    }, n);
  };
}, R = {
  props: f,
  setup(e, n) {
    const t = v(), a = v(!1), i = O(g.UseGlobalLeafletInjection), y = l.assertInject(g.AddLayerInjection);
    h(g.CanSetParentHtmlInjection, () => !!t.value.getElement()), h(g.SetParentHtmlInjection, (r) => {
      var d, m;
      const s = l.isFunction((d = t.value) == null ? void 0 : d.getElement) && ((m = t.value) == null ? void 0 : m.getElement());
      s && (s.innerHTML = r);
    }), h(
      g.SetIconInjection,
      (r) => {
        var s;
        return ((s = t.value) == null ? void 0 : s.setIcon) && t.value.setIcon(r);
      }
    );
    const { options: u, methods: o } = _(e, t, n), c = {
      moveHandler: M(o.latLngSync, 100)
    };
    return L(async () => {
      const r = i ? l.WINDOW_OR_GLOBAL.L : await import("leaflet/dist/leaflet-src.esm"), { marker: s, divIcon: d } = r;
      p.Marker.shouldBlankIcon(u, n) && (u.icon = d()), r.Marker.prototype.setRotationAngle || b(r), t.value = await A(s(e.latLng, u)), t.value.setRotationAngle(e == null ? void 0 : e.rotationAngle);
      const { listeners: m } = l.remapEvents(n.attrs);
      t.value.on(m), t.value.on("move", c.moveHandler), l.propsBinder(o, t.value, e), y({
        ...e,
        ...o,
        leafletObject: t.value
      }), a.value = !0, I(() => n.emit("ready", t.value));
    }), k(() => l.cancelDebounces(c)), { ready: a, leafletObject: t };
  },
  render() {
    return p.Layer.render(this.ready, this.$slots);
  }
};
export {
  R as LMarkerRotate
};
